cd "C:\Users\10281\Desktop"
use "C:\Users\10281\Desktop\data-提交.dta" ,clear
**************************************************************************
gen lncitybond=log(1+citybond)
gen lnbalance=log(1+balance)
gen lnbonds_jj=log(1+bonds_jj)

gen citybond_cen=citybond/GDP
gen citybond_sum_cen=citybond_sum/GDP
gen citybond_av_cen=citybond_av/GDP

gen balance_cen=balance/GDP
gen balance_sum_cen=balance_sum/GDP
gen balance_av_cen=balance_av/GDP

gen bonds_jj_cen=bonds_jj/GDP
gen bonds_jj_sum_cen=bonds_jj_sum/GDP
gen bonds_jj_av_cen=bonds_jj_av/GDP

gen lngdppc=log(gdppc)
gen lnpopden=log(popden)



winsor2 citybond balance bonds_jj self_sufficiency gdp_str secind_str lngdppc share_landrevenue lnpopden,replace cuts(0.5 99.5)
global xset="self_sufficiency d_age gdp_str secind_str  lngdppc  lnpopden"
xtset citycode year


*******************************
****表1  主要变量描述性统计****
*******************************
sum citybond balance bonds_jj self_sufficiency d_age gdp_str secind_str lngdppc  lnpopden nnum





*******************************
*****表2  邻居数量与城投债*****
*******************************
tobit citybond nnum ,ll(0)
est store table1_1

tobit balance nnum ,ll(0)
est store table1_11

tobit citybond nnum $xset i.year i.provcode,ll(0)
est store table1_2

tobit balance nnum $xset i.year i.provcode,ll(0)
est store table1_3

tobit bonds_jj nnum $xset i.year i.provcode,ll(0)
est store table1_4


outreg2 [table1_1 table1_11 table1_2 table1_3 table1_4 ] using table2.xlm,dec(3) replace


*******************************
****表3  城投债的局部加总效应***
*******************************
tobit citybond_cen citybond_sum_cen  $xset i.year i.citycode,ll(0) 
est store citybond

tobit balance_cen balance_sum_cen  $xset i.year i.citycode,ll(0) 
est store balance

tobit bonds_jj_cen bonds_jj_sum_cen  $xset i.year i.citycode,ll(0)
est store bonds_jj

outreg2 [citybond balance bonds_jj ] using table3.xls,dec(3) replace


*******************************
****表4  城投债的局部平均效应**
*******************************
tobit citybond_cen  citybond_av_cen $xset i.year i.citycode,ll(0)
est store citybond

tobit balance_cen  balance_av_cen $xset i.year i.citycode,ll(0) 
est store balance

tobit bonds_jj_cen  bonds_jj_av_cen $xset i.year i.citycode,ll(0)
est store bonds_jj

outreg2 [citybond balance bonds_jj ] using table4.xls,dec(3) replace


*******************************
*****表5  区分两种效应  *******
*******************************
tobit citybond_cen citybond_sum_cen citybond_av_cen $xset i.year  i.citycode,ll(0)
est store citybond

tobit balance_cen balance_sum_cen balance_av_cen $xset i.year i.citycode,ll(0)
est store balance

tobit bonds_jj_cen bonds_jj_sum_cen bonds_jj_av_cen $xset i.year i.citycode,ll(0)
est store bonds_jj

outreg2 [citybond balance bonds_jj ] using table5.xls,dec(3) replace



********************************
*********附录 省内效应***************
********************************
gen citybond_sum_prov_cen=citybond_sum_prov/GDP
gen citybond_av_prov_cen=citybond_av_prov/GDP

gen balance_sum_prov_cen=balance_sum_prov/GDP
gen balance_av_prov_cen=balance_av_prov/GDP


gen bonds_jj_sum_prov_cen=bonds_jj_sum_prov/GDP
gen bonds_jj_av_prov_cen=bonds_jj_av_prov/GDP


* 省外邻居的影响
gen citybond_sum_prov_0=citybond_sum-citybond_sum_prov  //省外邻居总和
gen citybond_sum_prov_0_cen=citybond_sum_prov_0/GDP //中心化
gen citybond_av_prov_0=citybond_sum_prov_0/(nnum-nnum_prov) //省外邻居均值
gen citybond_av_prov_0_cen=citybond_av_prov_0/GDP

gen balance_sum_prov_0=balance_sum-balance_sum_prov  //省外邻居总和
gen balance_sum_prov_0_cen=balance_sum_prov_0/GDP //中心化
gen balance_av_prov_0=balance_sum_prov_0/(nnum-nnum_prov) //省外邻居均值
gen balance_av_prov_0_cen=balance_av_prov_0/GDP


gen bonds_jj_sum_prov_0=bonds_jj_sum-bonds_jj_sum_prov  //省外邻居总和
gen bonds_jj_sum_prov_0_cen=bonds_jj_sum_prov_0/GDP //中心化
gen bonds_jj_av_prov_0=bonds_jj_sum_prov_0/(nnum-nnum_prov) //省外邻居均值
gen bonds_jj_av_prov_0_cen=bonds_jj_av_prov_0/GDP



tobit citybond_cen citybond_sum_prov_0_cen citybond_av_prov_0_cen $xset i.year i.citycode,ll(0)
est store cprov_0

tobit balance_cen balance_sum_prov_0_cen balance_av_prov_0_cen $xset i.year i.citycode,ll(0)
est store bprov_0

tobit bonds_jj_cen bonds_jj_sum_prov_0_cen bonds_jj_av_prov_0_cen $xset i.year i.citycode,ll(0)
est store jprov_0

outreg2 [cprov_0 bprov_0 jprov_0 ] using prov_0.xls,dec(3) replace



***省内邻居
tobit citybond_cen citybond_sum_prov_cen citybond_av_prov_cen $xset i.year i.citycode,ll(0)  
est store t1
tobit balance_cen balance_sum_prov_cen balance_av_prov_cen $xset i.year i.citycode,ll(0)  
est store t2
tobit bonds_jj_cen bonds_jj_sum_prov_cen bonds_jj_av_prov_cen $xset i.year i.citycode,ll(0)  
est store t3
outreg2 [t1 t2 t3 ] using prov1.xls,dec(3) replace





********************************
***********附录 IV估计***************
********************************
gen citybond_sum2_cen=citybond_sum2/GDP
gen citybond_av2_cen=citybond_av2/GDP

gen balance_sum2_cen=balance_sum2/GDP
gen balance_av2_cen=balance_av2/GDP


gen bonds_jj_sum2_cen=bonds_jj_sum2/GDP
gen bonds_jj_av2_cen=bonds_jj_av2/GDP



***邻居的邻居作为工具变量***
ivtobit citybond_cen  $xset (citybond_sum_cen =citybond_sum2_cen )  i.year i.citycode, twos ll(0) 
est store citybondsum
ivtobit citybond_cen  $xset (citybond_av_cen =citybond_av2_cen )  i.year i.citycode, twos ll(0) 
est store citybondsav

ivtobit balance_cen  $xset (balance_sum_cen =balance_sum2_cen )  i.year i.citycode, twos ll(0) 
est store balancesum
ivtobit balance_cen  $xset (balance_av_cen =balance_av2_cen )  i.year i.citycode, twos ll(0)  
est store balanceav

outreg2 [citybondsum citybondsav balancesum balanceav]  using tableiv.xls,dec(3) replace




***用滞后项做工具变量***
ivtobit citybond_cen  $xset (citybond_sum_cen =l.citybond_sum_cen l2.citybond_sum_cen) i.year i.citycode, twos ll(0)   
est store ivl1
ivtobit citybond_cen  $xset (citybond_av_cen =l.citybond_av_cen l2.citybond_av_cen)  i.year i.citycode, twos ll(0)   
est store ivl2

ivtobit balance_cen  $xset (balance_sum_cen =l.balance_sum_cen l2.balance_sum_cen)  i.year i.citycode, twos ll(0)   
est store ivl3
ivtobit balance_cen  $xset (balance_av_cen =l.balance_av_cen l2.balance_av_cen)  i.year i.citycode, twos ll(0)  
est store ivl4
outreg2 [ivl1 ivl2 ivl3 ivl4] using tableivlag.xls,dec(3) replace




********************************
********附录 加入经济权重矩阵********
********************************

****经济权重局部平均效应***
tobit citybond_cen  spcitybond_cen $xset i.year i.citycode,ll(0)
est store max1

tobit balance_cen  spbalance_cen $xset i.year i.citycode,ll(0) 
est store max2

tobit bonds_jj_cen  spbonds_cen $xset i.year i.citycode,ll(0)
est store max3


***比较地理和经济局部平均***
tobit citybond_cen citybond_sum_cen citybond_av_cen spcitybond_cen $xset i.year  i.citycode,ll(0)
est store max4

tobit balance_cen  balance_sum_cen balance_av_cen spbalance_cen $xset i.year i.citycode,ll(0) 
est store max5

tobit bonds_jj_cen  bonds_jj_sum_cen bonds_jj_av_cen spbonds_cen $xset i.year i.citycode,ll(0) 
est store max6

outreg2 [max1 max2 max3 max4 max5 max6] using max.xls,dec(3) replace




**********************************
***附录 图 城市的度、特征向量中心性与发债次数的关系***
**********************************
bys citycode:egen balance1=mean(balance)
bys citycode:egen citybond1=mean(citybond)

gen lnbalance1=ln(1+balance1)
gen lncitybond1=ln(1+citybond1)

***中心度：
twoway (scatter lncitybond1 nnum)(lfit lnbalance nnum)
graph save degree1.gph,replace
twoway (scatter lnbalance1 nnum)(lfit lnbalance nnum)
graph save degree2.gph,replace
grc1leg degree1.gph degree2.gph
graph save degree_combine.gph,replace


***特征向量中心性：
twoway (scatter lncitybond1 eigencentrality)(lfit lncitybond eigencentrality)
graph save centrality1.gph,replace
twoway (scatter lnbalance1 eigencentrality)(lfit lnbalance eigencentrality)
graph save centrality2.gph,replace
grc1leg centrality1.gph centrality2.gph
graph save centrality_combine.gph,replace


